searchNodes=[{"doc":"","ref":"Imageflow.html","title":"Imageflow","type":"module"},{"doc":"","ref":"Imageflow.html#get_long_version_string/0","title":"Imageflow.get_long_version_string/0","type":"function"},{"doc":"","ref":"Imageflow.Job.html","title":"Imageflow.Job","type":"module"},{"doc":"","ref":"Imageflow.Job.html#add_input_buffer/3","title":"Imageflow.Job.add_input_buffer/3","type":"function"},{"doc":"","ref":"Imageflow.Job.html#add_input_file/3","title":"Imageflow.Job.add_input_file/3","type":"function"},{"doc":"","ref":"Imageflow.Job.html#add_output_buffer/2","title":"Imageflow.Job.add_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Job.html#create/0","title":"Imageflow.Job.create/0","type":"function"},{"doc":"","ref":"Imageflow.Job.html#create!/0","title":"Imageflow.Job.create!/0","type":"function"},{"doc":"","ref":"Imageflow.Job.html#destroy/1","title":"Imageflow.Job.destroy/1","type":"function"},{"doc":"","ref":"Imageflow.Job.html#get_output_buffer/2","title":"Imageflow.Job.get_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Job.html#message/3","title":"Imageflow.Job.message/3","type":"function"},{"doc":"","ref":"Imageflow.Job.html#save_output_to_file/3","title":"Imageflow.Job.save_output_to_file/3","type":"function"},{"doc":"","ref":"Imageflow.Job.html#t:native_ret_t/0","title":"Imageflow.Job.native_ret_t/0","type":"type"},{"doc":"","ref":"Imageflow.Job.html#t:t/0","title":"Imageflow.Job.t/0","type":"type"},{"doc":"","ref":"Imageflow.Native.html","title":"Imageflow.Native","type":"module"},{"doc":"","ref":"Imageflow.Native.html#error/0","title":"Imageflow.Native.error/0","type":"function"},{"doc":"","ref":"Imageflow.Native.html#get_long_version_string/0","title":"Imageflow.Native.get_long_version_string/0","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_add_input_buffer/3","title":"Imageflow.Native.job_add_input_buffer/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_add_input_file/3","title":"Imageflow.Native.job_add_input_file/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_add_output_buffer/2","title":"Imageflow.Native.job_add_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_create/0","title":"Imageflow.Native.job_create/0","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_destroy/1","title":"Imageflow.Native.job_destroy/1","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_get_output_buffer/2","title":"Imageflow.Native.job_get_output_buffer/2","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_message/3","title":"Imageflow.Native.job_message/3","type":"function"},{"doc":"","ref":"Imageflow.Native.html#job_save_output_to_file/3","title":"Imageflow.Native.job_save_output_to_file/3","type":"function"},{"doc":"ImageflowExElixir bindings for Imageflow, a safe and blazing fast image workflow library.","ref":"readme.html","title":"ImageflowEx","type":"extras"},{"doc":"Add the package to your mix.exs:def deps do [ {:imageflow_ex, &quot;~&gt; 0.1.0&quot;} ] end","ref":"readme.html#installation","title":"ImageflowEx - Installation","type":"extras"},{"doc":"Querying an imagealias Imageflow.Job # create a job {:ok, job} = Job.create() # add an input file, with id `0` :ok = Job.add_input_file(job, 0, &quot;input.jpg&quot;) # you could also add input buffers directly from memory :ok = Job.add_input_buffer(job, 1, &lt;&lt;0x89, 0x50, 0x4E, 0x47, 0x0D, ... &gt;&gt;) # call `get_image_info` on buffer with id 0 {:ok, resp} = Job.message(&quot;v0.1/get_image_info&quot;, %{io_id: 0}) IO.inspect(resp) %{ &quot;code&quot; =&gt; 200, &quot;data&quot; =&gt; %{ &quot;image_info&quot; =&gt; %{ &quot;frame_decodes_into&quot; =&gt; &quot;bgr_32&quot;, &quot;image_height&quot; =&gt; 273, &quot;image_width&quot; =&gt; 185, &quot;preferred_extension&quot; =&gt; &quot;jpg&quot;, &quot;preferred_mime_type&quot; =&gt; &quot;image/jpeg&quot; } }, &quot;message&quot; =&gt; &quot;OK&quot;, &quot;success&quot; =&gt; true }Transforming an imagealias Imageflow.Job {:ok, job} = Job.create() :ok = Job.add_input_file(job, 0, &quot;input.jpg&quot;) # allocate an output buffer before manipulating the image :ok = Job.add_output_buffer(job, 2) # define a JSON task to transform your image (more details below) task = %{ ... } # run {:ok, response} = Job.message(job, &quot;v0.1/execute&quot;, task) # save the output buffer to a file :ok = Job.save_output_to_file(job, 1, &quot;output.jpg&quot;)Defining tasksImageflow accepts JSON task definitions. Since this package is only a binding to imageflow, the most reliable documentation on the JSON api available is from the here, in the crate docsHere's a simple example, which defines a task that takes buffer 0 as input, constrains the image to 50px of width, and saves the output to buffer 1:task = %{ framewise: %{ steps: [ # first step is to decode buffer 0 %{ decode: %{ io_id: 0 } }, # then constrain with to 50px %{ constrain: %{ mode: &quot;within&quot;, w: 50 } }, # and encode current result to buffer 1 %{ encode: %{ io_id: 1, preset: %{ pngquant: %{&quot;quality&quot; =&gt; 80} } } } ] } }More complex use casesAs you can probably guess from the API so far, imageflow isn't constrained to a single input/output per job. A common use case for web development would be to generate multiple sizes of an image for a responsive frontend. More details on details can be found in the imageflow repo","ref":"readme.html#usage","title":"ImageflowEx - Usage","type":"extras"},{"doc":"Feel free to contribute. Either by opening an issue, a Pull Request, or contacting the team directlyIf you found a bug, please open an issue. You can also open a PR for bugs or new features. PRs will be reviewed and subject to our style guide and linters.AboutThis project was developed by Miguel Palhas, and is published under the ISC license.","ref":"readme.html#contributing","title":"ImageflowEx - Contributing","type":"extras"}]